import 'dart:io';
import 'constants.dart';
import 'adfurikun_plugin.dart';

enum AdfurikunUserGender {
  other,
  male,
  female
}

class AdfurikunSdk {
  // ユーザー性別の設定（other、male、female）
  static void setUserGender(AdfurikunUserGender gender) {
    if (gender == AdfurikunUserGender.male) {
      AdfurikunPlugin.invoke(METHOD_SET_USER_GENDER_MALE, {});
    } else if (gender == AdfurikunUserGender.female) {
      AdfurikunPlugin.invoke(METHOD_SET_USER_GENDER_FEMALE, {});
    } else {
      AdfurikunPlugin.invoke(METHOD_SET_USER_GENDER_OTHER, {});
    }
  }

  // ユーザー年齢の設定
  static void setUserAge(int age) {
    AdfurikunPlugin.invoke(METHOD_SET_USER_AGE, {KEY_INT: age});
  }

  // 広告音の出力設定（true: 音有り、false: 音無し）
  static void setSoundState(bool state) {
    AdfurikunPlugin.invoke(METHOD_SET_SOUND_STATE, {KEY_BOOL: state});
  }

  // テスト広告モード設定（true: テスト広告、false: 本番広告）
  static void setTestMode(bool mode) {
    AdfurikunPlugin.invoke(METHOD_SET_TEST_MODE, {KEY_BOOL: mode});
  }

  // ユーザーGDPR同意の設定（true: 同意する、false: 同意しない）
  static void setUserConsent(bool hasUserConsent) {
    AdfurikunPlugin.invoke(METHOD_SET_USER_CONSENT, {KEY_BOOL: hasUserConsent});
  }

  // (iOSのみ) 詳細なデバッグログを出力する
  static void outputDetailedLog() {
    if (Platform.isIOS) {
      AdfurikunPlugin.invoke(METHOD_OUTPUT_DETAILED_LOG, {});
    }
  }
}
